#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <math.h>
#include "timing.h"

int main(int argc, char *argv[])
{
int N = atoi(argv[1]);
int nthreads = atoi(argv[2]);
unsigned long ticksB4, ticksAFT, ticks;
double freq = 2.5e9;

double *a;
double *b;
int lengthA = N;
int lengthB = 3*N;

a = (double *) malloc(lengthA * sizeof(double) );
b = (double *) malloc(lengthB * sizeof(double) );

int i, j;

for(i=0; i<lengthA; i++) {
	a[i] = (double) i;
}
for(i=0; i<lengthB; i++) {
	b[i] = (double) i;
}

get_ticks(ticksB4);

omp_set_nested(1);

#pragma omp parallel sections num_threads(nthreads) private(i)
{


#pragma omp section
	#pragma omp parallel for num_threads(1) schedule(static,1)
	for(i=6;i<lengthA;i++)
	{
		a[i] = pow(a[i],0.6) + pow(a[i-2],0.6);
	}

#pragma omp section
	#pragma omp parallel for num_threads(3) schedule(static,1)
	for(i=6;i<lengthB;i++)
	{
		b[i] = pow(b[i],0.6) + pow(b[i-6],0.6);
	}

}

get_ticks(ticksAFT);
ticks = ticksAFT - ticksB4;

#if 0
printf("\na:");
for(i=2; i<N; i++) {
	printf(" %.3g", a[i]);
}
printf("\n\n");

printf("\nb:");
for(i=2; i<N; i++) {
	printf(" %.3g", b[i]);
}
printf("\n\n");
#endif

printf("runtime (s): %g\n\n", ticks/freq);

return 0;
}
